diff --git a/app/test-pmd/cmdline.c b/app/test-pmd/cmdline.c
index 4559d59..83ed2b2 100644
--- a/app/test-pmd/cmdline.c
+++ b/app/test-pmd/cmdline.c
@@ -17604,6 +17604,51 @@ struct cmd_config_per_queue_tx_offload_result {
 	}
 };
 
+/* *** ENABLE METADATA INSERTION IN TX PACKETS SENT TO PMD *** */
+struct cmd_tx_metadata_set_result {
+	cmdline_fixed_string_t tx_metadata;
+	cmdline_fixed_string_t set;
+	portid_t port_id;
+	uint32_t metadata;
+};
+
+static void
+cmd_tx_metadata_set_parsed(void *parsed_result,
+		       __attribute__((unused)) struct cmdline *cl,
+		       __attribute__((unused)) void *data)
+{
+	struct cmd_tx_metadata_set_result *res = parsed_result;
+
+	tx_metadata_set(res->port_id, res->metadata);
+}
+
+cmdline_parse_token_string_t cmd_tx_metadata_set_tx_metadata =
+	TOKEN_STRING_INITIALIZER(struct cmd_tx_metadata_set_result,
+				tx_metadata, "tx_metadata");
+cmdline_parse_token_string_t cmd_tx_metadata_set_set =
+	TOKEN_STRING_INITIALIZER(struct cmd_tx_metadata_set_result,
+				 set, "set");
+cmdline_parse_token_num_t cmd_tx_metadata_set_portid =
+	TOKEN_NUM_INITIALIZER(struct cmd_tx_metadata_set_result,
+			      port_id, UINT16);
+cmdline_parse_token_num_t cmd_tx_metadata_set_metadata =
+	TOKEN_NUM_INITIALIZER(struct cmd_tx_metadata_set_result,
+			      metadata, UINT32);
+
+cmdline_parse_inst_t cmd_tx_metadata_set = {
+	.f = cmd_tx_metadata_set_parsed,
+	.data = NULL,
+	.help_str = "tx_metadata set <port_id> <metadata>: "
+		    "Enable metadata insertion in packets sent to PMD",
+	.tokens = {
+		(void *)&cmd_tx_metadata_set_tx_metadata,
+		(void *)&cmd_tx_metadata_set_set,
+		(void *)&cmd_tx_metadata_set_portid,
+		(void *)&cmd_tx_metadata_set_metadata,
+		NULL,
+	},
+};
+
 /* ******************************************************************************** */
 
 /* list of instructions */
@@ -17869,6 +17914,7 @@ struct cmd_config_per_queue_tx_offload_result {
 	(cmdline_parse_inst_t *)&cmd_operate_bpf_ld_parse,
 	(cmdline_parse_inst_t *)&cmd_operate_bpf_unld_parse,
 #endif
+	(cmdline_parse_inst_t *)&cmd_tx_metadata_set,
 	NULL,
 };
 
diff --git a/app/test-pmd/config.c b/app/test-pmd/config.c
index 70b2cce..b87c691 100644
--- a/app/test-pmd/config.c
+++ b/app/test-pmd/config.c
@@ -3828,3 +3828,9 @@ struct igb_ring_desc_16_bytes {
 
 	printf("\n\n");
 }
+
+void
+tx_metadata_set(portid_t port_id, uint32_t metadata)
+{
+	ports[port_id].metadata = metadata;
+}
diff --git a/app/test-pmd/testpmd.c b/app/test-pmd/testpmd.c
index 969eb7c..cd6823d 100644
--- a/app/test-pmd/testpmd.c
+++ b/app/test-pmd/testpmd.c
@@ -776,6 +776,7 @@ static void eth_dev_event_callback(char *device_name,
 		/* set flag to initialize port/queue */
 		port->need_reconfig = 1;
 		port->need_reconfig_queues = 1;
+		port->metadata = 0;
 	}
 
 	/*
diff --git a/app/test-pmd/testpmd.h b/app/test-pmd/testpmd.h
index a1f6614..10b0cd3 100644
--- a/app/test-pmd/testpmd.h
+++ b/app/test-pmd/testpmd.h
@@ -183,6 +183,7 @@ struct rte_port {
 #ifdef SOFTNIC
 	struct softnic_port     softport;  /**< softnic params */
 #endif
+	uint32_t                metadata; /**< metadata value to add in tx packets (debug only) */
 };
 
 /**
@@ -743,6 +744,8 @@ enum print_warning {
 queueid_t get_allowed_max_nb_txq(portid_t *pid);
 int check_nb_txq(queueid_t txq);
 
+void tx_metadata_set(portid_t port_id, uint32_t metadata);
+
 /*
  * Work-around of a compilation error with ICC on invocations of the
  * rte_be_to_cpu_16() function.
diff --git a/app/test-pmd/txonly.c b/app/test-pmd/txonly.c
index 1f08b6e..5d55d52 100644
--- a/app/test-pmd/txonly.c
+++ b/app/test-pmd/txonly.c
@@ -253,6 +253,16 @@
 		pkt->l2_len = sizeof(struct ether_hdr);
 		pkt->l3_len = sizeof(struct ipv4_hdr);
 		pkts_burst[nb_pkt] = pkt;
+
+		/*
+		 * If user configured metadata value add it to packet
+		 * and set ol_flags accordingly
+		 */
+		if (ports[fs->tx_port].metadata)
+		{
+			pkt->hash.fdir.hi = ports[fs->tx_port].metadata;
+			pkt->ol_flags |= PKT_TX_METADATA;
+		}
 	}
 	nb_tx = rte_eth_tx_burst(fs->tx_port, fs->tx_queue, pkts_burst, nb_pkt);
 	/*
diff --git a/doc/guides/testpmd_app_ug/testpmd_funcs.rst b/doc/guides/testpmd_app_ug/testpmd_funcs.rst
index 28da560..cfedf2d 100644
--- a/doc/guides/testpmd_app_ug/testpmd_funcs.rst
+++ b/doc/guides/testpmd_app_ug/testpmd_funcs.rst
@@ -851,6 +851,13 @@ Disable hardware insertion of a VLAN header in packets sent on a port::
 
    testpmd> tx_vlan reset (port_id)
 
+tx_metadata set
+~~~~~~~~~~~~~~~
+
+Set metadata value to insert in packets sent to PMD::
+
+   testpmd> tx_metadata set (port_id) (value)
+
 csum set
 ~~~~~~~~
 